@ECHO OFF
SETLOCAL EnableExtensions EnableDelayedExpansion

REM Defines the default executable to use
SET EXE=..\zdoom.exe

REM If your zdoom.ini file is in a location other than the default, put the path to your ZDoom .ini file here:
SET ZDoomINI="..\zdoom-%username%.ini"

REM This defines the IWAD to use if a PWAD is loaded
SET IWAD="..\doom2.wad"

SET FILES=.\BStone.pk7
SET INI=".\zdoom-%username%-BStone.ini"
SET LOADIWAD=0

SET ARGS=

CALL :ParseLoop %*
CALL :CheckINI
CALL :Launch

GOTO :EOF

:ParseLoop
	IF "%~1"=="" (
		GOTO :EOF
	) ELSE IF /I "%~1"=="-exe" (
		REM If a -exe command line parameter was provided, change the executable
		SET EXE=..\%~2.exe
		SHIFT
	) ELSE (
		SET ARGS=%ARGS% %1
		REM If a -file command line parameter was provided, automatically load the IWAD as defined above
		REM IF /I "%~1"=="-file" 
		SET LOADIWAD=1
	)
	SHIFT
	GOTO :ParseLoop
GOTO :EOF

:CheckINI
	IF NOT EXIST !INI! (
		REM If not, do initial setup for first run
		COPY %ZDoomINI% "!INI!"
		SET ARGS=%ARGS% +exec BStone.cfg
	)
GOTO :EOF

:Launch
	IF /I !LOADIWAD! GTR 0 SET ARGS=-file %IWAD% %ARGS%

	REM Change to the current directory so that you can drag and drop from other folders and the paths will still work
	CD "%~dp0"

  	START %EXE% -file %FILES% -config !INI! !ARGS!
GOTO :EOF